
;DATE : 22.4.1998 about 8.pm
;SUBJECT : Viliam Mateicka,N.Teslu 1,92101 Piestany,SLOVAKIA,EUROPE (-=METYL=-)
;CREATED FOR : Apatia Systems Inc.
;DESCRIPTION : a VESA compatible FLC / FLI player for DOS & win
;	       I don't use XMS,but about 64k base memory
;Email : metyl@frix.fri.utc.sk
;Published under GNU GPL v 2.0

.286
model tiny
dataseg
codeseg
Startupcode

jmp @MAIN

lods_b MACRO regs
LOCAL  @notcarryl
       mov  regs,ds:[si]
       inc  si
       cmp  si,65535
       jnz  @notcarryl
       call load
  @notcarryl:
ENDM

stos_b MACRO
LOCAL  @notcarrys
       mov  es:[di],al
       add di,1
       jnc  @notcarrys
       call switch
  @notcarrys:
ENDM

lods_w MACRO reg1,reg2
LOCAL  @notc1,@notc2
       mov reg1,ds:[si]
       inc si
       cmp si,65535
       jnz @notc1
       call load
 @notc1:
       mov reg2,ds:[si]
       inc si
       cmp si,65535
       jnz @notc2
       call load
 @notc2:
ENDM

stos_w MACRO
LOCAL  @notc1s,@notc2s
       mov es:[di],al
       add di,1
       jnc @notc1s
       call switch
 @notc1s:
       mov es:[di],ah
       add di,1
       jnc @notc2s
       call switch
 @notc2s:
ENDM

Load                       Proc
.286
        pusha
        lea   si,readsize
        mov   cx,cs:[si]        ;low wood of size
        cmp   word ptr cs:[si+2],0       ;high word of size
        jz    @less64k
        mov   cx,65535
        sub   word ptr cs:[si],cx
        sbb   word ptr cs:[si+2],0       ;odcti od 32-b readsize cx
      @less64k:
        mov   ah,3fh
        mov   bx,cs:[handle]
        xor   dx,dx
        int   21h
        popa
        xor   si,si
        ret
Load                    Endp

Switch                proc
.286
        pusha
        mov   dx,cs:[bank]
        xor   bx,bx
        call  dword ptr cs:[call4f05h]
        inc   dx
        mov   cs:[bank],dx
        popa
        ret
Switch                 endp

Dispframedisknew             proc
.286

        mov   ah,3fh
        xor   dx,dx
        mov   bx,cs:[handle]
        mov   cx,4
        int   21h
        xor   si,si
        mov   ax,ds:[si]             ;low size frejmmu
        mov   dx,ds:[si+2]           ;high size frejmmu
        sub   ax,4
        sbb   dx,0
        mov   word ptr cs:[readsize],ax
        mov   word ptr cs:[readsize+2],dx

        call  load
        lodsw                 ;Zaciatok frejmu {musi byt FIFAh}
;{***********************PREFIX CHUNKS**************************************}
        cmp   ax,0f100h              ;prefix chunk
        jnz   @framechunk
        mov   cx,ds:[si]             ;size of prefix chunk
;        add   si,4
;        mov   dx,ds:[si]
        add   si,cx
;        sub   si,4
;        mov   ax,ds:[si]
        jmp   @exiting

@framechunk:
;{***********************FRAME CHUNKS***************************************}
        cmp   ax,0f1fah              ;frame chunk
        jnz   @exit

        mov   ax,ds:[si]             ;chunks
        add   si,8+2                   ;for future enhancement
        mov   dx,ax
        or    dx,dx
        jnz   @notExiting
@exit:  jmp   @exiting
@Notexiting:
@chunky:
        mov   ax,0a000h               ;destination
        mov   es,ax
        lods_w cl,ch                 ;size of chunk low
        lods_w al,ah                 ;high word
        lods_w bl,bh                 ;typ chunks
;{*********************}Chunk 4{********************************************}
;{(FLI_COLOR256) - 256-Level Color}
;{*********************}Chunk 11{*******************************************}
;{(FLI_COLOR) - 64-Level Color}
        cmp   bl,4
        jz    @shit
        cmp   bl,11
        jz    @shit
        jmp   @comp7
   @shit:
        mov   bp,bx
        push  dx
        lods_w bl,bh           ; pocet balikov na tuto kompresiu
        mov   es,cs:[pal_seg]  ;  v dest je teraz palete pointer
        xor   di,di

@packy1:
        xor   ax,ax
        lods_b al              ;ak al<>0 tak vynechaj al farieb
        mov   cx,3
        mul   cx
        add   di,ax
	xor  ax,ax
        lods_b al              ;pocet farieb ktore sa menia (0 = 256)
        cmp   al,0
        jnz   @notzero1
        mov   ah,1
    @notzero1:
        mov   cx,3
        mul   cx
        mov   cx,ax
    @color1chng:
              cmp bp,11
              jnz @shirnito
              rep   movsb
              jmp @okaj
       @shirnito:
              lods_b al
              shr  al,2
              stosb
              dec  cx
              jnz  @color1chng
    @okaj:
        dec   bx
        jnz   @packy1
        push  es
        push  ds
        pop   es
        pop   ds
                        ; xchg es,ds
        push  si
        xor   si,si     ;ofset paleta Ptr ;xchg di,si
        mov   dx,03c8h
        xor   ax,ax
        out   dx,al
        inc   dx
        mov   cx,768
        rep   outsb
        pop   si
        push  es
        pop   ds
                            ;nastavim na ds:[si] tmp na citanie
        pop   dx
        jmp   @eocase
;{*********************}Chunk 7{********************************************}
;{(FLI_SS2) - Word Aligned Delta Compression}
@comp7:
        cmp   bx,7
        jz    @shit7
        jmp   @comp12
     @shit7:
        push  dx
        lea   bp,bank
        mov   dx,cs:[yadd]
        mov   ax,cs:[xres]
        mul   dx                          ;calc yadd
        add   ax,cs:[xadd]
        adc   dx,0
        mov   di,ax
        mov   cs:[bp],dx
        call  switch
        lods_w dl,dh               ;pocet line
        push  di
        xor   cx,cx
@newlineSS2:
        lods_w al,ah               ;pocet packetov na line spec code
        mov   bx,ax
        cmp   ax,0
        jge   @first
        and   ax,16384           ;vypne 0-13 a 15 bit
        cmp   ax,16384
        jnz   @second
        pop   di
        push  dx
        mov   cx,cs:[bp]
        dec   cx
        neg   bx                 ;preskoc bx line a nedekrementuj pocet line
        mov   ax,cs:[xres]       ;asi width+xadd1+xadd2
        mul   bx
        add   dx,cx
        add   di,ax
        adc   dx,0
        mov   cs:[bp],dx
        call  Switch
        xor   cx,cx
        pop   dx
        push  di
        jmp   short @newlineSS2
  @second:
     ;  (na neparne flc)
        mov al,bl     ; to be stored
        pop di
        push di
        sub di,cs:[addall]
        dec di
        stos_b
        pop di
        push di
        jmp @NewlineSS2
@first:
       @notcc1:
        lods_b cl               ;skip count
        add   di,cx
        jnc   @notc38
        call  switch
       @notc38:
        lods_b cl               ;packet type
        cmp   cl,0
        jle   @storeW
                @cop:
                     lods_w al,ah           ;copy cl words
                     stos_w
                     dec   cl
                     jnz   @cop
                     jmp   short @endpack
              @storeW:
                     neg   cl
                     lods_w al,ah
                  @sto4:                       ;store cl words
                     stos_w
                     dec   cl
                     jnz   @sto4
        @endpack:
        dec   bx
        jz    @endeofchunk
        jmp   @first
       @endeofchunk:
        pop   bx        ; stary di
        add   bx,cs:[xres];
        sub   bx,di
        add   di,bx
        jnc   @notc44
        call  switch
        @notc44:
        push  di
        dec   dx
        jz    @notnewline
        jmp   @newlineSS2
       @notnewline:
        pop   di
        pop   dx
        jmp   @eocase

;{***********************}Chunk 12{*****************************************}
;{FLI_LC) - Byte Aligned Delta Compression}
@comp12:
        cmp   bx,12
        jz    @shit2
        jmp   @comp13
  @shit2:
        push  dx
        lodsw
        add   ax,cs:[yadd]
        mov   dx,cs:[xres]
        mul   dx
        mov   di,ax            ;vynecha ax*320 byte teda ax riadkov
	add   di,cs:[xadd]
	adc   dx,0  
        mov   cs:[bank],dx
        call  switch

        lodsw                  ;line packets
        mov   dx,ax
        push  di
        xor   cx,cx
   @lines:
          lodsb
          mov   bl,al
          or    bl,bl
          jz    @preskocline
      @packets:
               xor  ax,ax
               lodsb
               add  di,ax
	       jnc @notc102
               call switch
           @notc102: 	 
               lodsb
               mov  cl,al
               or   cl,cl
               jz   @nic
               jl   @low
                   @lab02:
                    lodsb
                    stos_b
                    dec cx
		    jnz @lab02
                    jmp  short @nic
               @low:
                    neg cl
                    lodsb
                   @lab01:
                    stos_b
                    dec cx
		    jnz @lab01
          @nic:
               dec   bl
               jnz   @packets
@preskocline:
        pop   bx
        add   bx,cs:[xres];
        sub   bx,di
        add   di,bx
        jnc   @notc442
        call  switch
        @notc442:
        push  di
        dec   dx
        jnz   @lines
        pop   di
        pop   dx
        jmp   @eocase
;{***************************}Chunk 13{*************************************}
;{(FLI_BLACK) - No Data}
@comp13:
        cmp   bx,13
        jnz   @comp15
        push  dx
	mov   dx,cs:[yadd]
        mov   ax,cs:[xres]
        mul   dx                          ;calc yadd
        mov   di,ax
        add   di,cs:[xadd]
        adc   dx,0

        mov   cs:[bank],dx
        call  switch
        mov   dx,cs:[height]
        xor   ax,ax

@loop1:
        mov   cx,cs:[_width]

 @xlab1:stos_B
        dec cx
        jnz @xlab1

        add   di,cs:[addall]
        jnc   @next22
        call  switch
@next22:
        dec   dx
        jnz   @loop1

        pop   dx
        jmp   @eocase
;{***************************}Chunk 15{*************************************}
;{(FLI_BRUN) - Byte Run Length Compression}
@comp15:
        cmp   bx,15
        jz    @ok21
        jmp   @comp16
     @ok21:
        push  dx
        mov   dx,cs:[yadd]
        mov   ax,cs:[xres]
        mul   dx                          ;calc yadd
        mov   di,ax
        add   di,cs:[xadd]
        adc   dx,0
        mov   cs:[bank],dx
        call  switch
        mov   dx,cs:[height]
        xor   cx,cx
        xor   bx,bx
@newline:
         lods_b bl           ;pocet packetov
 @newpack:
           lods_b cl
           cmp  cl,0
           jge  @store
                neg  cl
              @cop3:
                lods_b al
                stos_b
                dec  cx
                jnz  @cop3
                jmp  short @nic2
           @store:
                lods_b al
             @sto:
                stos_b
                dec  cx
                jnz  @sto
  @nic2:
           dec  bx
           jnz  @newpack
        add   di,cs:[addall]
        jnc   @notcc3
        call switch
       @notcc3:
        dec   dx
        jnz   @newline
        pop   dx
        jmp   @eocase
;{****************************}Chunk 16{************************************}
;{Chunk Type 16 (FLI_COPY) - No Compression}
@comp16:
        cmp   bx,16
        jnz   @comp18
	push  dx
        mov   dx,cs:[yadd]
        mov   ax,cs:[xres]
        mul   dx                          ;calc yadd
        mov   di,ax
        add   di,cs:[xadd]
        adc   dx,0
        mov   cs:[bank],dx
        call  switch
	
        mov   dx,cs:[height]

@loop:
        mov   cx,cs:[_width]
  @xlab:lods_b al
        stos_B
        dec cx
        jnz @xlab

        add   di,cs:[addall]
        jnc   @next2
	call  switch
@next2:
        dec   dx
        jnz   @loop

        pop   dx
        jmp   @eocase
;{****************************}Chunk 18{************************************}
;{(FLI_PSTAMP) - Postage Stamp Image}
@comp18:
        cmp   bx,18
        jnz   @Exiting
        sub   cx,6
        add   si,cx

;{***********************   EndOfCASE  **************************************}
@eocase:
        dec   dx               ;o jeden chunk menej a zase na zaciatok
        jz    @notchunky
        jmp   @chunky
        @notchunky:
;{*************************  EXIT  ******************************************}
@exiting:
        ret

Dispframedisknew            endp

@MAIN:
               mov   ah,4ah
               mov   bx,2000h+(768/16)
               int   21h		       ;realokuj 128k+768 pamate
               mov   dx,OFFSET msg_mem
               jc    @end
               mov   ax,cs
               add   ax,1000h
               mov   [tmp_seg],ax              ;segment s 64k pamate
               add   ax,1000h
               mov   [pal_seg],ax              ;segment s 768byte pamate

PARSE:         MOV     SI,81H                  ;Point to command line again.
NEXT_PARSE:    LODSB                           ;Get a byte.
               CMP     AL,' '                  ;Parse off leading delimiters.
               JA      LEADING_END
               OR      AL,AL                   ;If ASCIIZ reached, done.
               JNZ     NEXT_PARSE
LEADING_END:   MOV     DX,SI
               DEC     DX                      ;Adjust pointer.

FIND_END:      LODSB                           ;Find end of filespec.
               CMP     AL,' '                  ;If none white space, continue.
               JAE     FIND_END
               dec     si
               xor     al,al
               MOV     BYTE PTR [SI],al        ;ASCIIZ filespec.

               MOV     AX,3D00H                ;Open file for reading.
               INT     21H
               MOV     DX,OFFSET msg_found     ;if fail, exit with message.
               JC      @end

               mov     [handle],ax             ;uchovaj handle
               mov     bx,ax

               mov     ds,[tmp_seg]            ;nastav ds natemp
               mov     ah,3fh
               xor     dx,dx                   ;ofset na citanie
               mov     cx,128
               int     21h                     ;read head !

               mov     dx,OFFSET msg_fli
	       mov     ax,ds:[4]
	       and     ax,1111111111111100b
	       cmp     ax,0af10h
               jnz     @end                    ; je to flix ?
                                               ; je !
               mov     si,6
               mov     di,OFFSET frames
               mov     cx,7
               rep     movsw                   ;skopci hlavicku !
           ;nacitaj hlacivku
               jmp  @preskoc
@end:          
	       push cs
               pop ds	
	       mov si,dx
@vypis:
	       mov ah,0eh
	       lodsb   
               xor al,0
	       or al,al	         
               jz @xxx
	       mov ah,0eh
	       int 10h 	
               jmp @vypis
         @xxx:
               int 20h
       @preskoc:
               mov     ax,04f00h
               push    ds
               PUSH    CS
               POP     DS 
               pop     es
               xor     di,di
               int     10h

               mov     dx,OFFSET msg_vesa
               mov     si,OFFSET vesa 
               mov     cx,2
 	       rep     cmpsw
               or      cx,cx
	       jnz     @end

               lds     si,es:[di+10]           ;nastav na tabulku VESA modov
                                               ;a najdi prislusny videorezim
          @lop:
               lodsw
               mov dx,OFFSET msg_support
               or  ax,ax
               jz  @end
               mov cx,ax                       ;cislo modu
               mov ax,04f01h
               xor di,di                       ;info -> es:[di]
               int 10h                         ;do it !
               xor bx,bx

               mov ax,es:[di+18]               ;width
               cmp ax,cs:[_width]
               jb @no1
               inc bx
              @no1:
               mov ax,es:[di+20]               ;height
               cmp ax,cs:[height]
               jb @no2
               inc bx
              @no2:
               cmp byte ptr es:[di+25],8       ;depth
               jnz @no3
               inc bx
              @no3:

               cmp bx,3
               jnz @lop

               push cs                      ;ds=cs
               pop ds
                                            ;mod mame najdeny
               mov ax,es:[di+18]	    ;width
               mov [xres],ax
	       sub ax,[_width]              ;calc xadd

               mov [addall],ax              ;add all

               shr ax,1
               mov [xadd],ax

               adc ax,0
               mov [xadd2],ax

               mov ax,es:[di+20]	    ;height
               sub ax,[height]              ;calc yadd
               shr ax,1
               mov [yadd],ax

               mov si,12
               mov di,OFFSET call4f05h
               push es
               pop ds
               push cs
               pop es
	       movsw
	       movsw                ;nastav addresu prepinania bank

               ;v cx je stale cislo modu
               mov bx,cx
               mov ax,4f02h
               int 10h                         ;nastav najdeny videomod

      ;no a zacneme prehravat !
@START:
               mov  cx,cs:[frames]

               mov ds,cs:[tmp_seg]
      @nextframe:
               push cx

    mov dx,3DAh
  @WaitNotVSyncLoop:
    in   al,dx
    and  al,8
    jnz  @WaitNotVSyncLoop
  @WaitVSyncLoop:
    in   al,dx
    and  al,8
    jz   @WaitVSyncLoop
               
               call cs:[dispframedisknew]      ;ukaz frejm !

;	       mov ah,86h	;in cx:dx delay in ms
;	       mov cx,word ptr cs:[speed]
;	       mov dx,word ptr cs:[speed+2]
;	       int 15h
	       pop  cx
               dec  cx
               jnz  @nextframe

      ;close file
               mov  ah,3eh
               mov  bx,cs:[handle]
               int  21h
@sem:
	 in al,60h
         cmp al,80h
         ja @sem
      ;init egamode
               mov ax,3h
               int 10h

               mov dx,OFFSET msg_apatia
               jmp @end
vesa db 'VESA'
msg_mem     db 'Not memory',0
msg_found   db 'FLIC file not found',0
msg_fli     db 'Not FLIC file',0
msg_vesa    db 'Not VESA card',0
msg_support db 'Resolution not supported',0
msg_apatia  db '(c)1998 Apatia System Inc. by Viliam Mateicka, metyl@frix.fri.utc.sk -=METYL=-',0

frames  dw ?
_width  dw ?
height  dw ?
depth   dw ?
flags   dw ?
speed   dd ?   ;hlavicka (aspom kusok !)

call4f05h dd ?
handle  dw ?
pal_seg dw ?
tmp_seg dw ?
readsize dd ?
bank dw ?
xadd dw ?
xadd2 dw ?
addall dw ?

yadd dw ? 
xres dw ?

End