
;DATE : 29.7.1998 about 1.am
;SUBJECT : Viliam Mateicka,N.Teslu 1,92101 Piestany,SLOVAKIA,EUROPE (-=METYL=-)
;CREATED FOR : Apatia Systems Inc.
;DESCRIPTION : a VESA compatible GIF viewer for DOS & win (256 color)
;               only It don't use XMS,but about 64k+ base memory
;Email : metyl@frix.fri.utc.sk
;Published under GNU GPL v 2.0

.286
model tiny
org 100h
codeseg
startupcode
jmp @main

input_buffer    proc
         pusha
         push ds
	 push cs
	 pop ds
         mov bx,[handle]
         xor dx,dx
         mov [actofs],dx
         mov ds,[tmp_seg]
         mov ah,3fh
         mov cx,65000
         int 21h        ;nacti
         pop ds
         mov cs:[maxread],ax
         popa
         ret
input_buffer    endp

readbyte        proc    ;ret in al
          push bx
          mov bx,cs:[actofs]
          mov al,[bx]
          inc bx
          mov cs:[actofs],bx
          cmp bx,cs:[maxread]
          jnz @noread
          call input_buffer
@noread:
          pop bx
          ret
readbyte        endp

getdatablock proc      ;input = di dest offset
                       ;ret count in ax
          xor ax,ax
          push si
          push ds
          push es
          push bx
          push cx
          push dx
          push cs
          pop es
          mov ds,cs:[tmp_seg]
          call readbyte

push ax
          or ax,ax
          jz @return
          mov bx,cs:[actofs]
          mov si,bx
          mov dx,cs:[maxread]
          mov cx,ax
          add ax,bx     ;actofs+count
          cmp ax,dx     ;actofs+count<=maxread
          jae @dalej
push ax
          rep movsb     ;move(ptr(seg(fbuf^),ofs(fbuf^)+actofs),buf,count);
pop ax
          mov cs:[actofs],ax
          jmp @return
@dalej:
          sub dx,bx     ;maxread-actofs;
push cx
          mov cx,dx
          rep movsb     ;move(ptr(seg(fbuf^),ofs(fbuf^)+actofs),buf,maxread-actofs);
          call input_buffer

pop cx                  ;count
          xor si,si     ;zac bufru

          sub cx,dx
          mov cs:[actofs],cx   ;count-(maxread-actofs);
          rep movsb     ;move(ptr(seg(fbuf^),ofs(fbuf^)+0),buf+maxread-actofs,count-(maxread-actofs));
@return:
pop ax
          pop dx
          pop cx
          pop bx
          pop es
          pop ds
          pop si
          ret
getdatablock endp


initLZW         proc
          xor ax,ax
          mov [last_bit],ax
          mov [cur_bit],ax
          inc ax
          inc ax
          mov [last_byte],ax
          dec ax
          mov cl,[input_code_size]
          shl ax,cl
          mov [clear_code],ax
          inc ax
          mov [end_code],ax
          call reinitLZW
          ret
initLZW         endp

reinitLZW       proc
                                ;reinit LZW
          xor ax,ax 
          mov al,[input_code_size]
          inc ax
          mov cs:[code_size],ax
          mov ax,[clear_code]
push ax
          shl ax,1
          mov [limit_code],ax
pop ax
push ax
          inc ax
          inc ax
          mov [maxcode],ax
          xor ax,ax
          mov [_sp],ax
pop ax
          ret
reinitLZW       endp


dispgif     proc
	  cli
          mov ax,[xres]
          mov bx,[yadd]
          mul bx
          mov di,ax
                    ;calc begin
	  xor bx,bx
	  call cs:[call4f05h]	;set begining window
@newline: add di,[_xadd]
          jnc @notcc02
	  xor bx,bx
          inc dx           
          call cs:[call4f05h]
@notcc02: mov cx,[_width]

@nextbyte2read&decode:
          push cx       ;save !!!!!!!
          push dx
          push di

          mov bx,cs:[_sp]
          cmp bx,0
          jbe empty_stack
          dec bx
          mov cs:[_sp],bx
          mov al,cs:[bx+symbol_stack]        ;If any codes are stacked from a previously read symbol, return them
          jmp @returnLZW
empty_stack:
          clc
@getcode:
          pushf
          push bx
          mov ax,[cur_bit]
          lea bx,codebuf
push ax
          add ax,[code_size]
          mov dx,[last_bit]
          cmp ax,dx
          jbe @nemenbuffer

          mov si,[last_byte]
          dec si                ;lastbyte-1
          mov al,[bx+si]
          mov cs:[bx+1],al         ;mov codebuf+1,codebuf+lastbyte-1
          dec si
          mov al,[bx+si]
          mov [bx],al           ;mov codebuf+0,codebuf+lastbyte-2

          mov di,bx
          add di,2
          call getdatablock      ;rets count in ax

 pop cx                         ;cur_bit
          sub cx,dx             ;cur_bit-last_bit
          add cx,16
          mov [cur_bit],cx
 push cx                         ;curbit
          add ax,2              ;last_byte=count +2
          mov [last_byte],ax
          mov cl,3
          shl ax,cl             ;last_bit=last_byte*8
          mov [last_bit],ax
@nemenbuffer:
pop ax                          ;cur_bit

push ax                         ;cur_bit
          mov cl,3
          shr ax,cl             ;cur_byte
          mov si,ax
          inc si
          inc si
          add si,bx
          std
          mov cl,8
.386
          lodsb
          shl eax,cl
          lodsb
          shl eax,cl
          lodsb

pop cx                          ;cur_bit
          mov dx,cx
          and cx,7
          shr eax,cl

          xor ebx,ebx
          mov cx,[code_size]
          add dx,cx
          mov [cur_bit],dx

          mov bx,1
          shl bx,cl
          dec bx

          and eax,ebx
          cld

          pop bx
          popf

          jc @este
                                                ;get in ax
          cmp ax,[clear_code]
          jnz @notcc
          call reinitLZW
          mov bx,ax                 ;bx=clear_code
@loop:
          stc
          jmp @getcode
@este:
          cmp ax,bx
          jz @loop
          jb @okay01
          jmp @TOTAL_EXIT2
@okay01:
          mov [oldcode],ax      ;oldcode=code
          mov [firstcode],ax    ;first_code=code;
          jmp @returnLZW

@notcc:   cmp ax,[end_code]
          jnz @notec
          xor ax,ax
          jmp @TOTAL_EXIT1
          jmp @returnLZW
@notec:
push ax                         ;save current code
          lea si,[symbol_stack]
          lea di,[symbol_tail]
          cmp ax,[maxcode]
          jb @next              ;special case for not-yet-defined symbol
;          jnz @TOTAL_EXIT3
          mov ax,[firstcode]
          mov [si+bx],al      ;will be defined as oldcode/firstcode
          inc bx                 ;_sp
          mov ax,[oldcode]
@next:
          cmp ax,[clear_code]
          jb  @next1
          push bx                ;_sp
          mov bx,ax              ;code
          mov dl,[di+bx]
          pop bx

          mov [si+bx],dl       ;symbol_stackcs:[sp]:= symbol_tailcs:[code];
          inc bx
          push si
          mov si,ax
          add si,si               ;si*2 word !!!
          mov ax,[symbol_head+si]       ;code := symbol_headcs:[code] word ;
          pop si
          jmp @next
@next1:
          mov [_sp],bx         ;_sp
          mov [firstcode],ax
          mov cx,ax
          mov bx,[maxcode]
          cmp bx,LZW_TABLE_SIZE ;Define a new symbol = prev sym + head of this sym's expansion
          ja  @next2
          mov ax,[oldcode]
push bx
          add bx,bx
          mov [symbol_head+bx],ax ;symbol_headcs:[code] := oldcode;
pop bx
          mov [di+bx],cl          ;symbol_tailcs:[code] := firstcode;
          inc bx                     ;maxcode
          mov [maxcode],bx
          mov ax,[limit_code]
          mov dx,[code_size]
          cmp bx,ax             ;if ((max_code >= limit_code) and (code_size < MAX_LZW_BITS))
          jb @nic
          cmp dx,MAX_LZW_BITS
          jae @nic
          inc dx
          shl ax,1
          mov [limit_code],ax
          mov [code_size],dx
@nic:
@next2:
          pop ax                ;incode
          mov [oldcode],ax
          mov ax,cx             ;return firstcode

@returnLZW:
          pop di                ;load !!!!!!!!!
          pop dx
          mov es:[di],al
          add di,1
          jnc @notcc01
          inc dx
	  xor bx,bx
          call cs:[call4f05h]
@notcc01:
          pop cx
          dec cx
          jnz @nextbyte2read&decode
          add di,[xadd2]
          jnc @notcc03
          inc dx
          xor bx,bx
	  call cs:[call4f05h]
@notcc03:
          dec [height]
          jnz @newline
	  sti
          ret
dispgif     endp

loadpal          proc
               mov dx,OFFSET msg_inter
	       jc @netestuj
               test al,40h
               ;jnz @END
@netestuj:
               test al,80h
               jz @notpal
               mov cs:[depth],al
	       mov cl,al
               and cl,7
               mov ax,2
               mov bx,3
               shl ax,cl
               mul bx
               mov cs:[colors],ax
               mov cx,ax
	       mov di,OFFSET pal
@lop:          call readbyte
               stosb
               dec cx
               jnz @lop
@notpal:       ret
loadpal          endp

setpal           proc
               mov al,cs:[depth]
               test al,80h
               jz @notpal1
	       push ds
	       push cs
	       pop ds
               lea si,[pal]

               mov dx,3c8h
               mov cx,[colors]
	       xor al,al
               out dx,al
               inc dx
@esteraz:
               lodsb
               shr al,2
               out dx,al
               dec cx
               jnz @esteraz
               pop ds
@notpal1:
                ret
setpal           endp



@main:
               mov   ah,4ah
               mov   bx,((2000h)+(1768/16))
               int   21h		       ;realokuj 64k+4k+4k+4k+program =+-90k pamate
               mov   dx,OFFSET msg_mem
               jc    @end
               mov   ax,cs
               add   ax,(1000h)
               mov   [tmp_seg],ax              ;segment s 64k pamate

PARSE:         MOV     SI,81H                  ;Point to command line again.
NEXT_PARSE:    LODSB                           ;Get a byte.
               CMP     AL,' '                  ;Parse off leading delimiters.
               JA      LEADING_END
               OR      AL,AL                   ;If ASCIIZ reached, done.
               JNZ     NEXT_PARSE
LEADING_END:   MOV     DX,SI
               DEC     DX                      ;Adjust pointer.

FIND_END:      LODSB                           ;Find end of filespec.
               CMP     AL,' '                  ;If none white space, continue.
               JAE     FIND_END
               dec     si
               xor     al,al
               MOV     BYTE PTR [SI],al        ;ASCIIZ filespec.

               MOV     AX,3D00H                ;Open file for reading.
               INT     21H
               MOV     DX,OFFSET msg_found     ;if fail, exit with message.
               JC      @end

               mov     [handle],ax             ;uchovaj handle
               mov     bx,ax

               mov     ds,[tmp_seg]            ;nastav ds natemp
               mov     ah,3fh
               xor     dx,dx                   ;ofset na citanie
               mov     si,dx
               mov     cx,13
               int     21h                     ;read head !
;nacitaj hlacivku
               mov     dx,OFFSET msg_gif
               cmp     cx,ax
               jnz     @end

               mov     cx,4
               mov     di,OFFSET gif
	       rep cmpsb
               or      cx,cx
               jnz     @end                    ; je to gif ?
                                               ; je !
               mov    cx,13-4
               rep    movsb                    ;skopci hlaVICu

               call   input_buffer              ;init  buffer
	       
               stc  	
               mov    al,cs:[depth] 
               call   loadpal

               jmp  @preskoc
@int:          mov dx,OFFSET msg_int
@end:
	       push cs
               pop ds
	       mov si,dx
@vypis:
	       mov ah,0eh
	       lodsb
               xor al,0
	       or al,al
               jz @xxx
	       mov ah,0eh
	       int 10h
               jmp @vypis
         @xxx:
               int 20h
       @preskoc:

;this repeats X count

@next_image:
               call    readbyte        ;ds must point -> tmp_seg
               cmp     al,'!'          ;extension
               jnz     @noextension
	       call    readbyte  
@este_dalsi:
	       lea     di,[codebuf]
	       call    getdatablock 
	       or      al,al
	       jnz     @este_dalsi  
@noextension:
	       cmp     al,';'
	       jz     @enden 
               cmp     al,','
               jnz     @next_image

;read local descriptor
               mov     cx,5
  @rep:        call readbyte            ;ignore some blbosti
	       loop    @rep
	       mov     bl,al
	       call    readbyte
	       mov     bh,al
	       mov     cs:[_width],bx
	       call    readbyte
	       mov     bl,al
	       call    readbyte
	       mov     bh,al
	       mov     cs:[height],bx

               call    readbyte
	       clc
               call    loadpal
               xor     ax,ax
               call    readbyte
               mov     cs:[input_code_size],al
               push    ds    ;es=cs ,ds=saved
	       push    cs
	       pop     ds

               mov     ax,04f00h
               mov     di,OFFSET symbol_head
               int     10h

               mov     dx,OFFSET msg_vesa
               mov     si,OFFSET vesa
               mov     cx,4
 	       rep     cmpsb
               or      cx,cx
	       jnz     @end
	       mov     bp,3
               lds     si,es:[di+10]           ;nastav na tabulku VESA modov
                                               ;a najdi prislusny videorezim
@semlo:
	       push    si
          @lo:
               lodsw
               mov dx,OFFSET msg_support
               cmp ax,0ffffh
               jz  @skus_menej
               mov cx,ax                       ;cislo modu
               mov ax,04f01h
               mov di,OFFSET symbol_head       ;info -> es:[di]
               int 10h                         ;do it !
               xor bx,bx
               mov al,es:[di]
	       test al,1
               jz @lo	 	 
               mov ax,es:[di+20]               ;height
               cmp ax,cs:[height]
               jb @no2
               inc bx
              @no2:
               cmp byte ptr es:[di+25],8       ;depth always 8-bit !!
               jz @o3
               xor bx,bx
               dec bx
              @o3:
               inc bx
               mov ax,es:[di+18]               ;_width
               cmp ax,cs:[_width]
               jae @no1
               xor bx,bx
              @no1:
               inc bx

               cmp bx,bp
               jnz @lo
               jmp @ok
  @skus_menej: dec bp
               cmp bp,1
               jz @END
	       pop si
	       jmp @semlo 

  @ok:	       pop si
               push cs
	       pop ds                                ;mod mame najdeny
               mov ax,[di+18]	            ;_width
               mov [xres],ax
	       sub ax,[_width]             ;calc xadd
               shr ax,1
               mov [_xadd],ax
               mov [xadd2],ax
               adc word ptr [xadd2],0

               mov ax,[di+20]	            ;height
               sub ax,[height]              ;calc yadd
	       jg  @zero
	       xor ax,ax
@zero:
               shr ax,1
               mov [yadd],ax

               mov si,OFFSET symbol_head+12
               mov di,OFFSET call4f05h
	       movsw
	       movsw                ;nastav addresu prepinania bank

               ;v cx je stale cislo modu
	       mov ax,[oldmode]
	       cmp ax,cx
	       jz @nemen
               mov bx,cx
               mov ax,4f02h
               lea dx,msg_support
               int 10h                         ;nastav najdeny videomod
	       or ah,ah
	       jnz @END	       
@nemen:
	       mov [oldmode],cx 
      ;no a zacneme prehravat !

               call [setpal]
               mov ax,0a000h
               mov es,ax
	       call [initLZW]
               call [dispgif]      ;ukaz gif !


@readkey:
	        mov ah,7h
                int 21h
	        or al,al
                jz @readkey
	        in al,60h
	        cmp al,1
                jz @enden
	        push cs
	        pop es
	        mov ds,[tmp_seg]
                jmp @next_image
@enden:
      ;close file
               mov  ah,3eh
               mov  bx,[handle]
               int  21h

      ;init egamode
               mov ax,3h
               int 10h

               mov dx,OFFSET msg_apatia
               jmp @end
vesa db 'VESA'
msg_mem     db 'Not memory',0
msg_inter   db 'Interlaced images not support',0
msg_found   db 'GIF file not found',0
msg_gif     db 'Not GIF file',0
msg_vesa    db 'Not VESA card',0
msg_support db 'Resolution not supported',0
msg_int     db 'GIF damaged',0
msg_apatia  db '(c)1998 Apatia System Inc. by Viliam Mateicka, metyl@frix.fri.utc.sk -=METYL=-',0
oldmode	    dw 0
gif db 'GIF8'

;hlavicka (aspom kusok !)
head :

lowversion dw ?
_width      dw ?
height     dw ?
depth      db ?
neviem     db ?
aspratio   db ?
colors dw ?

tmp_seg   dw ?
call4f05h dd ?
_xadd dw ?
xadd2 dw ?
yadd dw ?
xres dw ?

pal db  768 dup(?)

LZW_TABLE_SIZE EQU 4096
CODE_BUF_SIZE  EQU 256+8
MAX_LZW_BITS   EQU 12
handle          dw ?
actofs          dw ?
maxread         dw ?
codebuf         db CODE_BUF_SIZE+1 dup(?)
last_byte       dw ?                     ;# of bytes in code_buf
last_bit        dw ?                     ;# of bits in code_buf
cur_bit         dw ?                     ;next bit index to read

input_code_size db ?                     ;codesize given in GIF file
code_size       dw ?                     ;current actual code size
limit_code      dw ?                     ;2^codesize
maxcode         dw ?                     ;first unused code value

clear_code      dw ?
end_code        dw ?

oldcode         dw ?                     ;previous LZW symbol
firstcode       dw ?                     ;first byte of oldcode expanzion

symbol_head     dw LZW_TABLE_SIZE+1 dup(?)
symbol_tail     db LZW_TABLE_SIZE+1 dup(?)
symbol_stack    db LZW_TABLE_SIZE+1 dup(?)
_sp             dw ?


@TOTAL_EXIT1:
@TOTAL_EXIT2:
@TOTAL_EXIT3:
end