
;DATE : 9.5.1998 about 8.pm
;SUBJECT : Viliam Mateicka,N.Teslu 1,92101 Piestany,SLOVAKIA,EUROPE (-=METYL=-)
;CREATED FOR : Apatia Systems Inc.
;DESCRIPTION : a VESA compatible PCX viewer for DOS & win for 256 color
;               only It don't use XMS,but about 64k+ base memory
;Email : metyl@frix.fri.utc.sk
;Published under GNU GPL v 2.0

.286
MODEL TINY
CODESEG
STARTUPCODE

jmp  @MAIN

lods_b MACRO
LOCAL  @notcarryl
       mov  al,ds:[si]
       inc  si
       cmp  si,cs:[readed]
       jnz  @notcarryl
       call load
  @notcarryl:
ENDM

stos_b MACRO
LOCAL  @notcarrys,@nott
       mov  es:[di],al
       dec  bp
       or   bp,bp
       jnz  @nott

       mov  bp,cs:[scanbyte]
       xor  dx,dx
       add  di,cs:[xadd2]
       adc  dx,0
       add  di,cs:[xadd]
       adc  dx,0
       or   dx,dx
       jz   @nott
       add  dx,cs:[bank]
       dec  dx  	
       mov  cs:[bank],dx
       call switch
@nott:
       add  di,1
       jnc  @notcarrys
       call switch
  @notcarrys:
ENDM

Load 	   proc

           pusha
           lea si,readsize
           mov cx,cs:[si]
           cmp word ptr cs:[si+2],0
           jz @low
           mov cx,65535
@low:
           sub cs:[si],cx
           sbb word ptr cs:[si+2],0
	   mov ah,3fh
	   xor dx,dx
           mov cs:[readed],cx   ;tolko sme nacitali
	   or  cx,cx
	   jnz @@notenden
	   jmp @enden
@@notenden:	   
	   mov bx,cs:[handle]
           int 21h
	   popa
           xor si,si
           ret

Load	   Endp

switch     proc
           mov dx,cs:[bank]
	   xor bx,bx 
	   call dword ptr cs:[call4f05h]
           inc dx
           mov cs:[bank],dx
           ret

switch     endp

dispPCX    proc

       call Load 		;init buffer,linecounter,bank
       mov ax,cs:[xres]		;set start writing ofset
       mov bx,cs:[yadd]
       mul bx
       add ax,cs:[xadd]
       adc dx,0	
       mov di,ax		;set ofset	
       mov bp,cs:[scanbyte]
       mov cs:[bank],dx		;set bank
       call switch	
@newchunk:
       lods_b                       ; DO AL
                                    ; INC SEEK BUFFERU
       mov cx,ax                    ; RLE RUN LENGHT ENCODING
       and cx,192                   ; AK DATA AND 192 = 192
       cmp cx,192                   ; TAK TADY MAME KOMPRESIU ???
       je @comp                     ; ano  !!!!
       stos_b                      ; normal
       jmp @newchunk
@comp:
       mov cx,ax                    ; DO CX POCET OPAKOVANI
       and cx,63                    ;
       lods_b                       ; CO OPAKOVAT
                                    ; INC SEEK
@lop1:  stos_b                       ; DO DEST OFSETU
       dec cx
       jnz @lop1
       jmp @newchunk
       ret

dispPCX    endp



@MAIN:
               mov   ah,4ah
               mov   bx,2000h+(768/16)
               int   21h		       ;realokuj 128k+768 pamate
               mov   dx,OFFSET msg_mem
               jc    @end
               mov   ax,cs
               add   ax,1000h
               mov   [tmp_seg],ax              ;segment s 64k pamate
               add   ax,1000h
               mov   [pal_seg],ax              ;segment s 768byte pamate

PARSE:         MOV     SI,81H                  ;Point to command line again.
NEXT_PARSE:    LODSB                           ;Get a byte.
               CMP     AL,' '                  ;Parse off leading delimiters.
               JA      LEADING_END
               OR      AL,AL                   ;If ASCIIZ reached, done.
               JNZ     NEXT_PARSE
LEADING_END:   MOV     DX,SI
               DEC     DX                      ;Adjust pointer.

FIND_END:      LODSB                           ;Find end of filespec.
               CMP     AL,' '                  ;If none white space, continue.
               JAE     FIND_END
               dec     si
               xor     al,al
               MOV     BYTE PTR [SI],al        ;ASCIIZ filespec.

               MOV     AX,3D00H                ;Open file for reading.
               INT     21H
               MOV     DX,OFFSET msg_found     ;if fail, exit with message.
               JC      @end

               mov     [handle],ax             ;uchovaj handle
               mov     bx,ax

               mov     ds,[tmp_seg]            ;nastav ds natemp
               mov     ah,3fh
               xor     dx,dx                   ;ofset na citanie
               mov     cx,128
               int     21h                     ;read head !

;nacitaj hlacivku
               mov     dx,OFFSET msg_pcx
               xor     si,si
	       mov     ax,ds:[si+2]
	       cmp     ax,0801h                ; encoding + depth
               jnz     @end                    ; je to pcx ?
                                               ; je !
               mov     di,OFFSET head
               mov     cx,(endhead-head) / 2
               rep     movsw                   ;skopci hlavicku !

;paleta
               mov ax,4202h             ;seek na konec
               cwd
               xor cx,cx
               int 21h                  ;dx:ax
               sub ax,769
               sbb dx,0



               mov cx,dx
               mov dx,ax                ; cx:dx
	       mov ax,4200h             ;seek na konec-768
               int 21h

  	       lea si,readsize		;

               jmp  @preskoc
@end:
	       push cs
               pop ds
	       mov si,dx
@vypis:
	       mov ah,0eh
	       lodsb
               xor al,0
	       or al,al
               jz @xxx
	       mov ah,0eh
	       int 10h
               jmp @vypis
         @xxx:
               int 20h
       @preskoc:

	       sub ax,128		;odecti hlavicku a uloz readsize
	       sbb dx,0
	       mov cs:[si],ax
	       mov cs:[si+2],dx

               mov ah,3fh               ;nacti paletu do cs+1000h:65535-769
               mov cx,769
               mov dx,65535-769
               int 21h

               mov     ax,04f00h
               push    ds
               push    cs
               pop     ds
               pop     es

               xor     di,di
               int     10h

               mov     dx,OFFSET msg_vesa
               mov     si,OFFSET vesa
               mov     cx,2
 	       rep     cmpsw
               or      cx,cx
	       jnz     @end

               ;calc height

               mov     ax,[ymax]
               sub     ax,[ymin]
               mov     [height],ax
	       mov     bp,3
               lds     si,es:[di+10]           ;nastav na tabulku VESA modov
                                               ;a najdi prislusny videorezim
@semlo:
	       push    si
          @lo:
               lodsw
               mov dx,OFFSET msg_support
               cmp ax,0ffffh
               jz  @skus_menej
               mov cx,ax                       ;cislo modu
               mov ax,04f01h
               xor di,di                       ;info -> es:[di]
               int 10h                         ;do it !
               xor bx,bx
               mov al,es:[di]
	       test al,1
               jz @lo	 	 

               mov ax,es:[di+20]               ;height
               cmp ax,cs:[height]
               jb @no2
               inc bx
              @no2:
               cmp byte ptr es:[di+25],8       ;depth always 8-bit !!
               jz @o3
               xor bx,bx
               dec bx
              @o3:
               inc bx
               mov ax,es:[di+18]               ;_width
               cmp ax,cs:[scanbyte]
               jae @no1
               xor bx,bx
              @no1:
               inc bx

               cmp bx,bp
               jnz @lo
               jmp @ok
  @skus_menej: dec bp
               cmp bp,1
               jnz @noend
               jmp @END
  @noend:
	       pop si
	       jmp @semlo 

  @ok:	       pop si

               ;v cx je stale cislo modu
               mov bx,cx
               mov ax,4f02h
               int 10h                         ;nastav najdeny videomod
               mov dx,OFFSET msg_support
	       or ah,ah
	       jz @finded
               jmp @end
  @finded:

               push cs
	       pop ds                                ;mod mame najdeny
               mov ax,es:[di+18]	       ;width
               mov [xres],ax
	       sub ax,[scanbyte]            ;calc xadd
               shr ax,1
               mov [xadd],ax
               mov [xadd2],ax
               adc word ptr [xadd2],0

               mov ax,es:[di+20]	       ;height
               sub ax,[height]              ;calc yadd
 	       jg  @zero
	       xor ax,ax
@zero:

               shr ax,1
               mov [yadd],ax

               mov si,12
               mov di,OFFSET call4f05h
               push es
               pop ds
               push cs
               pop es
	       movsw
	       movsw                ;nastav addresu prepinania bank

      ;no a zacneme prehravat !
@START:
	       mov ax,4200h		;seek za hlavu
	       mov dx,128
	       mov bx,cs:[handle]
	       xor cx,cx
	       int 21h

               mov ds,cs:[tmp_seg]
               mov ax,0a000h
	       mov es,ax

               mov si,65535-769
               lodsb

               cmp al,0ch
               jnz @notpal
               mov dx,3c8h
               mov cx,768
	       xor al,al
               out dx,al
               inc dx
@este:
               lodsb
               shr al,2
               out dx,al
               dec cx
               jnz @este

@notpal:


               call cs:[disppcx]      ;ukaz pcx !

@enden:	       

      ;close file
               mov  ah,3eh
               mov  bx,cs:[handle]
               int  21h
@sem:
	 in al,60h
         cmp al,1
         jz @semnie
         jmp @sem

      @semnie:
      ;init egamode
               mov ax,3h
               int 10h

               mov dx,OFFSET msg_apatia
               jmp @end
vesa db 'VESA'
msg_mem     db 'Not memory',0
msg_found   db 'PCX file not found',0
msg_pcx     db 'Not PCX file',0
msg_vesa    db 'Not VESA card',0
msg_support db 'Resolution not supported',0
msg_apatia  db '(c)1998 Apatia System Inc. by Viliam Mateicka, metyl@frix.fri.utc.sk -=METYL=-',0

;hlavicka (aspom kusok !)
head :

manufacturer   db ?
_version        db ?
encoding       db ?
depth          db ?
xmin           dw ?
ymin           dw ?
xmax           dw ?
ymax           dw ?
hres           dw ?
vres           dw ?
palette        db 48 dup(?)
reserved2      db ?
color_planes  db ?
scanbyte       dw ?
palette_type   dw ?

endhead:

call4f05h dd ?
handle  dw ?
pal_seg dw ?
tmp_seg dw ?
readsize dd ?
bank dw ?
xadd dw ?
xadd2 dw ?
yadd dw ?
xres dw ?
height dw ?

readed dw ?

END